import 'package:json_path/src/expression/expression.dart';

/// A named function which can be used in a JSONPath expression.
abstract class NamedFun {
  /// Function name.
  String get name;
}

/// A function which can be used in a JSONPath expression.
abstract class Fun<R> extends NamedFun {
  /// Attaches the given arguments and creates a function expression.
  /// This method MUST throw an [Exception] if the provided [args]
  /// have the incorrect length or types.
  Expression<R> toExpression(List<Expression> args);
}

/// A named function with one argument.
abstract class Fun1<R, A1> extends NamedFun {
  /// Attaches the given arguments and creates a function expression.
  /// This method MUST throw an [Exception] on invalid args.
  Expression<R> toExpression1(Expression<A1> arg1);
}